def merge_listing_responses(resps):
    assert len(resps) >= 1
    assert "ls" in resps[0], str(resps[0])
    ls = list(resps[0]["ls"])
    for i in range(1, len(resps)):
        ls_i = resps[i]["ls"]
        continue_after = None
        for p in range(-1, -16, -1):
            for c in range(min(24, len(ls_i))):
                if ls_i[c]["name"] == ls[p]["name"]:
                    continue_after = c
                    break
            if continue_after is not None:
                ls.extend(ls_i[continue_after + 1 :])
                break
        assert continue_after is not None
    return ls
